// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "testbed.h"
#include "ChildView.h"
#include "point2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CChildView

CChildView::CChildView()
{
}

CChildView::~CChildView()
{
}


BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_PAINT()
END_MESSAGE_MAP()



// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), reinterpret_cast<HBRUSH>(COLOR_WINDOW+1), NULL);

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// Handle isotropic mapping
	CRect win;
	GetClientRect(&win);
	dc.SetMapMode(MM_ISOTROPIC);
	dc.SetWindowExt(480,-320);
	dc.SetViewportExt(win.Width(),win.Height());
	dc.SetViewportOrg(win.Width()/2,win.Height()/2);
	// Draw a reference grid
	CPen pen (PS_SOLID,0,RGB(220,220,255));
	CPen *oldpen = (CPen *) dc.SelectObject(&pen);
	int u = 4*point2::resolution;
	for (int i=-4; i<=4; i++) {
		int v = i*point2::resolution;
		dc.MoveTo(-u,v);
		dc.LineTo(u,v);
		dc.MoveTo(v,-u);
		dc.LineTo(v,u);
	}
	dc.SelectObject(oldpen);
	int w = 5;
	dc.Ellipse(-w,-w,w,w);

	void drawResistor(CDC &dc, Vec2 &loc);
	void drawImpedance(CDC &dc, Vec2 &loc);
	void drawCapacitor(CDC &dc, Vec2 &loc);
	void drawInductor(CDC &dc, Vec2 &loc);
	void drawCurrentSource(CDC &dc, Vec2 &loc);
	drawResistor(dc,Vec2(-1,1));
	drawInductor(dc,Vec2(-2,-1));
	drawCapacitor(dc,Vec2(-2,-1));
	drawImpedance(dc,Vec2(1,1));
	drawResistor(dc,Vec2(-2,-1));
	drawInductor(dc,Vec2(-2,0));
	drawCapacitor(dc,Vec2(2,0));
	drawCurrentSource(dc,Vec2(0,0));
	
	// Do not call CWnd::OnPaint() for painting messages
}

