//
#include "stdafx.h"
#include "point2.h"


void drawResistor(CDC &dc, Vec2 &loc)
{
	const double w = 2.5/7.0;
	const double y = 1.25;
	Vec2 pts[] = { Vec2(-7*w,0), Vec2(-6*w,0), Vec2(-5*w,y), Vec2(-3*w,-y), Vec2(-w,y), Vec2(w,-y), 
		Vec2(3*w,y), Vec2(5*w,-y), Vec2(6*w,0), Vec2(7*w,0) };
	int npts = sizeof(pts)/sizeof(pts[0]);
	int i;
	CPoint *cpts = new CPoint[npts];
	for (i=0; i<npts; i++) {
		pts[i].scale(0.1).translate(loc);
		point2::convert(pts[i],cpts[i]);
	}
	/*
	CRect rect(0,0,2,2);
	dc.DPtoLP(&rect);
	int width = rect.Width();
	CString str;
	if (width<2) width = 2;
	str.Format("pen width %d",rect.Width());
	dc.TextOut(50,-50,str);
	*/
	int color = RGB(0,0,255);
	CPen pen(PS_SOLID,2,color);
	CPen *oldpen = (CPen *) dc.SelectObject(&pen);
	dc.Polyline(cpts,npts);
	dc.SelectObject(oldpen);
	delete [] cpts;
}

void drawImpedance(CDC &dc, Vec2 &loc)
{
	Vec2 pts[] = { Vec2(-2.5,1.25), Vec2(2.5,-1.25) };
	int i, npts;
	npts = sizeof(pts)/sizeof(pts[0]);
	CPoint *cpts = new CPoint[npts];
	for (i=0; i<npts; i++) {
		pts[i].scale(0.1).translate(loc);
		point2::convert(pts[i],cpts[i]);
	}
	CBrush brush(RGB(220,220,255));
	CBrush *oldbrush = (CBrush *) dc.SelectObject(&brush);
	CRect rect(cpts[0],cpts[1]);
	dc.Rectangle(rect);
	dc.SelectObject(oldbrush);
	int mode = dc.GetBkMode();
	dc.SetBkMode(TRANSPARENT);
	CString str("Z");
	dc.DrawText(str,rect,DT_CENTER | DT_SINGLELINE | DT_VCENTER);
	dc.SetBkMode(mode);
	delete [] cpts;
}

void drawCapacitor(CDC &dc, Vec2 &loc)
{
	Vec2 pts[] = { Vec2(-2.5,0), Vec2(-0.5,0), Vec2(0.5,0), Vec2(2.5,0), Vec2(-0.5,-1.5), Vec2(-0.5,1.5),
			Vec2(1,-1.5), Vec2(0.5,-1.5), Vec2(0.5,-0.5), Vec2(0.5,0.0), Vec2(0.5,0.5),
			Vec2(0.5,1.5), Vec2(1.0,1.5) };
	int npts = sizeof(pts)/sizeof(pts[0]);
	int i;
	CPoint *cpts = new CPoint[npts];
	for (i=0; i<npts; i++) {
		pts[i].scale(0.1).translate(loc);
		point2::convert(pts[i],cpts[i]);
	}
	int color = RGB(0,255,0);
	CPen pen(PS_SOLID,2,color);
	CPen *oldpen = (CPen *) dc.SelectObject(&pen);
	for (i=0; i<6; i+=2) {
		dc.MoveTo(cpts[i]); dc.LineTo(cpts[i+1]);
	}
	dc.PolyBezier(cpts+6,7);
	dc.SelectObject(oldpen);
	delete [] cpts;
}

void drawInductor(CDC &dc, Vec2 &loc)
{
	Vec2 spts[] = { Vec2(-2.75,0), Vec2(-2.75,2), Vec2(-1.25,2), Vec2(-1.25,0), 
		Vec2(-1.25,-1), Vec2(-1.75,-1) };
	int i, j, k, npts;
	npts = sizeof(spts)/sizeof(spts[0]);
	Vec2 *pts = new Vec2[5*npts];
	k = 0;
	for (j=0; j<5; j++) {
		Vec2 t(j,0.0);
		for (i=0; i<npts; i++) {
			pts[k++]=spts[i]+t;
		}
	}
	npts = 4*npts+4;
	double w = pts[npts-1][0];
	w = 0.25/w;
	CPoint *cpts = new CPoint[npts];
	for (i=0; i<npts; i++) {
		pts[i].scale(w).translate(loc);
		point2::convert(pts[i],cpts[i]);
	}
	int color = RGB(255,0,0);
	CPen pen(PS_SOLID,2,color);
	CPen *oldpen = (CPen *) dc.SelectObject(&pen);
	dc.PolyBezier(cpts,npts);
	dc.SelectObject(oldpen);
	delete [] pts;
	delete [] cpts;
}

void drawCurrentSource(CDC &dc, Vec2 &loc)
{
	Vec2 pts[] = { Vec2(-2.5,-2.5), Vec2(2.5,2.5), Vec2(0,-2), Vec2(0,2), Vec2(-0.7,0),
		Vec2(0,0.8), Vec2(0.7,0)};
	int i, npts;
	npts = sizeof(pts)/sizeof(pts[0]);
	CPoint *cpts = new CPoint[npts];
	for (i=0; i<npts; i++) {
		pts[i].scale(0.1).translate(loc);
		point2::convert(pts[i],cpts[i]);
	}
	CPen pen(PS_SOLID,2,RGB(0,0,0));
	CPen *oldpen = (CPen *) dc.SelectObject(&pen);
	CRect rect(cpts[0],cpts[1]);
	dc.Ellipse(&rect);
	dc.MoveTo(cpts[2]); dc.LineTo(cpts[3]);
	CBrush brush(RGB(0,0,0));
	CBrush *oldbrush = (CBrush *) dc.SelectObject(&brush);
	dc.Polygon(cpts+3,npts-3);
	dc.SelectObject(oldbrush);
	dc.SelectObject(oldpen);
	delete [] cpts;
}